unit Unit1;

interface

uses
  SysUtils, Types, Classes, QGraphics, QControls, QForms, QDialogs,
  QStdCtrls, DBXpress, DB, SqlExpr, QExtCtrls, FMTBcd, QGrids, QDBGrids,
  QTypes, DBClient, Provider, QDBCtrls, QComCtrls;

type
  TForm1 = class(TForm)
    SQLConnection1: TSQLConnection;
    SQLMonitor1: TSQLMonitor;
    GroupBoxConn: TGroupBox;
    EditUser: TEdit;
    EditHost: TEdit;
    EditPassword: TEdit;
    ButtonConnetti: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    GroupBoxMonitor: TGroupBox;
    MemoMonitor: TMemo;
    GroupBoxTabelle: TGroupBox;
    GroupBoxTable: TGroupBox;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    TimerMonitor: TTimer;
    DataSetCommand: TSQLDataSet;
    DataSetProvider1: TDataSetProvider;
    ClientDataSetCommand: TClientDataSet;
    ListBoxTables: TListBox;
    Splitter1: TSplitter;
    ListBoxFields: TListBox;
    PanelFields: TPanel;
    Label4: TLabel;
    Panel1: TPanel;
    Splitter2: TSplitter;
    ListBoxIndex: TListBox;
    Label5: TLabel;
    Panel2: TPanel;
    Panel3: TPanel;
    Label6: TLabel;
    DBNavigator1: TDBNavigator;
    Splitter3: TSplitter;
    Splitter4: TSplitter;
    Splitter5: TSplitter;
    StatusBar1: TStatusBar;
    Label7: TLabel;
    EditDBName: TEdit;
    procedure ButtonConnettiClick(Sender: TObject);
    procedure ButtonClientiClick(Sender: TObject);
    procedure TimerMonitorTimer(Sender: TObject);
    procedure SQLConnection1BeforeDisconnect(Sender: TObject);
    procedure SQLConnection1BeforeConnect(Sender: TObject);
    procedure SQLConnection1AfterConnect(Sender: TObject);
    procedure SQLConnection1AfterDisconnect(Sender: TObject);
    procedure ListBoxTablesClick(Sender: TObject);
    procedure DataSetCommandBeforeClose(DataSet: TDataSet);
    procedure ClientDataSetCommandAfterPost(DataSet: TDataSet);
    procedure ListBoxFieldsClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.xfm}

procedure TForm1.ButtonConnettiClick(Sender: TObject);
begin
      with SQLConnection1 do
        if Connected then
          try
            Connected := false;
          except
            ShowMessage('Impossibile disconnettersi dal server.');
          end
        Else
          try
            Connected := true;
          except
            ShowMessage('Impossibile connettersi dal server.');
          end;
end;


procedure TForm1.ButtonClientiClick(Sender: TObject);
begin
        try
          with DataSetCommand do
          begin
            If Active Then Close;
            CommandType := ctTable;
            CommandText := 'clienti';
            Open;
          end;
          with ClientDataSetCommand do
          begin
            If Active Then Close;
            Open;
          end;
        except
          ShowMessage('Impossibile eseguire la query.');
        end;
end;

procedure TForm1.SQLConnection1BeforeConnect(Sender: TObject);
begin
        SQLMonitor1.Active := true;
        with SQLConnection1.Params do
        begin
          Strings[IndexOfName('HostName')] := 'HostName=' +EditHost.Text;
          Strings[IndexOfName('Database')] := 'Database=' +EditDBName.Text;
          Strings[IndexOfName('User_name')] := 'User_name=' +EditUser.Text;
          Strings[IndexOfName('Password')] := 'Password=' +EditPassword.Text;
        end;
end;

procedure TForm1.SQLConnection1AfterConnect(Sender: TObject);
begin
  ShowMessage('"'+EditUser.Text+'" connesso al server Sql all''host "'+EditHost.Text+'".');
  ButtonConnetti.Caption := 'Disconnetti';
  ListBoxTables.Clear;
  TimerMonitor.Enabled := true;
  SQLConnection1.GetTableNames(ListBoxTables.Items);
  with ListBoxTables do
    If Items.Count>0 Then
      ItemIndex := 0;
end;

procedure TForm1.SQLConnection1BeforeDisconnect(Sender: TObject);
begin
  If ClientDataSetCommand.Active Then
    ClientDataSetCommand.Close;
  If DataSetCommand.Active Then
    DataSetCommand.Close;
end;

procedure TForm1.SQLConnection1AfterDisconnect(Sender: TObject);
begin
  TimerMonitor.Enabled := false;
  SQLMonitor1.Active :=false;
  if Not Application.Terminated Then
  begin
    ButtonConnetti.Caption := 'Connetti';
    ListBoxIndex.Clear;
    ListBoxFields.Clear;
    ListBoxTables.Clear;
  end;
end;

procedure TForm1.TimerMonitorTimer(Sender: TObject);
begin
      if TimerMonitor.Enabled Then
        If SQLConnection1.Connected Then
        begin
          if MemoMonitor.Text<>SQLMonitor1.TraceList.Text Then
            MemoMonitor.Lines.Assign(SQLMonitor1.TraceList);
        end
        else
          if MemoMonitor.Lines.Count>0 Then
            MemoMonitor.Clear;
end;

procedure TForm1.ListBoxTablesClick(Sender: TObject);
Var
  I: Integer;
begin
  With ListBoxTables do
    If ItemIndex > -1 Then
      try
        with DataSetCommand do
        begin
          SQLConnection1.GetFieldNames(Items[ItemIndex],ListBoxFields.Items);
          SQLConnection1.GetIndexNames(Items[ItemIndex],ListBoxIndex.Items);
          GroupBoxTable.Caption := Items[ItemIndex];
          If Active Then Close;
          CommandType := ctTable;
          CommandText := Items[ItemIndex];
          Open;
          With ClientDataSetCommand  Do
          begin
            If Active Then Close;
            Open;
            for I := 0 To FieldCount-1 Do
            Begin
              If Fields[I].IsIndexField Then
                Fields[I].DisplayLabel := Fields[I].DisplayLabel +'*';
              If Fields[I].DisplayWidth > 20 Then
                Fields[I].DisplayWidth := 20;
            End;
          end;
        end;
      except
        ShowMessage('Impossibile aprire la tabella "'+Items[ItemIndex]+'".');
      end;
end;

procedure TForm1.DataSetCommandBeforeClose(DataSet: TDataSet);
begin
        ClientDataSetCommand.Close;
end;

procedure TForm1.ClientDataSetCommandAfterPost(DataSet: TDataSet);
begin
        ClientDataSetCommand.ApplyUpdates(0);
end;

procedure TForm1.ListBoxFieldsClick(Sender: TObject);
begin
  With ListBoxFields do
    If ItemIndex > -1 Then
      try
        with DBGrid1 do
        begin
          SelectedField := ClientDataSetCommand.FieldByName(Items[ItemIndex]);
        end;
      except
        ShowMessage('Impossibile selezionare il campo "'+Items[ItemIndex]+'".');
      end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  SQLMonitor1.FileName := ExtractFilePath(Application.ExeName)+ExtractFileName(SQLMonitor1.FileName);
end;

end.
